
//ZHdK-Zechenmodul Dezember 2013
//Florian Herzog VIAD-FS13

/*
Keys        Beschreibung
 
 'UP'            shapeSize vergrössern
 'DOWN'          shapeSize verkleinern
 'd'             sizeMode verändern (mouserOver-Veränderung)
 'p'             Anzahl transfomationSteps verringern
 'o'             Anzahl transformationSteps erhöhen
 '1-7'            Zeichen verändern
 'links-Click'   Zeichen anziehen
 'rechts-Click'  Zeichen abstossen
 'r'             Background wird rot
 't'             Background wird weniger rot
 'g'             Background wird grün
 'h'             Background wird weniger grün
 'b'             Background wird blau
 'n'             Background wird weniger blau
 **/

//////////////////////////////////////////////////////////////////////

float grid = 10;
int border = 85;
float xStep;
float yStep;
int xPos;
int yPos;

int transformation = 1;
int transformationSteps = 0;
int sizeMode = 0;
int fillMode = 0;
int shapeSize = 30;
int red = 50;
int green = 50;
int blue = 50;


int[] objectArray = {
  1, 2, 3, 4, 5, 6, 7, 8, 9, 10
};

ArrayList<PermutationBase> objList;

//////////////////////////////////////////////////////////////////////

void setup() {
  size(800, 800);
  shapeMode(CENTER);
  smooth();


  xStep = ((width - (2 * border)) / (grid - 1));  // Abstand für jedes Zeichen berechnen
  yStep = ((height - (2 * border)) / (grid - 1)); // ''


  objList = new ArrayList<PermutationBase>();  //ArrayList wird erstellt


  int xPos = 0;
  int yPos = 0;

  for (int x = 0; x < grid; x++) {  //Grid erstellen
    for (int y = 0; y < grid; y++) {

      xPos = (int)(x * xStep + border); // Jew. Abstand zwischen den Objekten
      yPos = (int)(y * yStep + border);

      objList.add(new PermutationBase(xPos, yPos, 1)); // Syntax (xPosition, yPosition, TransformationsIndex) Index ist über CaseType ersichtlich und wird übergeben
    }
  }
}


void draw() {
  PermutationBase obj;

  background(red,green,blue);

  for (int i=0;i < objList.size();i++)
    objList.get(i).update(mouseX, mouseY, mousePressed ? mouseButton:0);

  int newIndex;

  for (int i = 0; i < objList.size(); i++) {
    pushMatrix();

    obj = objList.get(i);
    newIndex = calcIndex(obj, objectArray.length);

    obj.version = transformation; // Übergabe der Werte an PermutationBase obj
    obj.shapeSize = shapeSize;
    obj.fillMode = fillMode;
    obj.drawType = objectArray[newIndex];
    obj.draw();

    popMatrix();
  }
}


void keyPressed() {
  
  
  if (keyCode == 'p' || keyCode == 'P') transformationSteps += 1;
  if (keyCode == 'o' || keyCode == 'O') transformationSteps -= 1;

  if (transformationSteps <= -1)
    transformationSteps = 0; 
  if (transformationSteps >= 10)
    transformationSteps = 0;

  
  if (keyCode == 'd' || keyCode == 'D') sizeMode = (sizeMode+1) % 3;

  if (keyCode == UP) shapeSize +=5;
  if (keyCode == DOWN) shapeSize = max(shapeSize-5, 5);
  
  if (keyCode == 'r' || keyCode == 'R') red += 10; // mehr Rot (background)
  if (keyCode == 't' || keyCode == 'T') red -=10; // weniger Rot
  if (keyCode == 'g' || keyCode == 'G') green += 10; // mehr Grün
  if (keyCode == 'h' || keyCode == 'H') green -=10; // weniger Grün
  if (keyCode == 'b' || keyCode == 'B') blue += 10; // mehr Blau
  if (keyCode == 'n' || keyCode == 'N') blue -=10; // weniger Blau
  
  
  
  switch(key) {

  case '1':
    transformation = 1;
    break;

  case '2':
    transformation = 2;
    break;

  case '3':
    transformation = 3;
    break;
    
  case '4':
    transformation = 4;
    break;
    
  case '5':
    transformation = 5;
    break;
    
  case '6':
    transformation = 6;
    break;
    
  case '7':
    transformation = 7;
    break;
  }
}


int calcIndex(PermutationBase obj, int maxIndex) { //Proportionale Aufteilung der Diogonale (längste Länge) auf Strecke MousePos zu jew. Objekt.
  float distance = dist(obj.posX, obj.posY, mouseX, mouseY);
  return (int)map(distance, 0, dist(0, 0, width, height), transformationSteps, maxIndex);
}

